Bio::Tools::Run::AnalysisFactory(3pm)

NAME
Bio::Tools::Run::AnalysisFactory - A directory of analysis tools

SYNOPSIS
  # list all available analyses from the default location,
  # using a default (SOAP) access method
  use Bio::Tools::Run::AnalysisFactory;
  my $list = Bio::Tools::Run::AnalysisFactory->new();
                ->available_analyses;
  use Data::Dumper; print Dumper ($list);

  # ditto, but from a different location
  use Bio::Tools::Run::AnalysisFactory;
  my $list =
     Bio::Tools::Run::AnalysisFactory->new(-location => 'http://somewhere/something')
                ->available_analyses;

  # ...and using a different access method
  # (this example is not yet impelmented)
  use Bio::Tools::Run::AnalysisFactory;
  my $list =
     Bio::Tools::Run::AnalysisFactory->new(-location => 'http://somewhere/something',
                                           -access => 'novella')
                ->available_analyses;

  # list available categories of analyses
  use Bio::Tools::Run::AnalysisFactory;
  my $categories =
     Bio::Tools::Run::AnalysisFactory->new();
                ->available_categories;
  use Data::Dumper; print Dumper ($categories);

  # show all analyses group by categories
  use Bio::Tools::Run::AnalysisFactory;
  my $factory = Bio::Tools::Run::AnalysisFactory->new();
  foreach $cat ( @{ $factory->available_categories } ) {
    my @sublist = @{ $factory->available_analyses ($cat) };
    print "$cat:\n\t",
          join ("\n\t", @{ $factory->available_analyses ($cat) }),
          "\n";
  }

  # create an analysis object
  use Bio::Tools::Run::AnalysisFactory;
  $service = Bio::Tools::Run::AnalysisFactory->new();
                 ->create_analysis ('edit.seqret');
  $service->run (
                #...
                )->results;

DESCRIPTION
The module represents a list of available analysis tools from a given location using a given access method. Additionally, for any of the available analyses, it can create an object of type "Bio::Tools::Run::Analysis".

The module is a higher-level abstraction whose main job is to load a 'real-work-doing' implementation. Which one is used, it depends on the "-access" parameter. The same design is used here as for "Bio::Tools::Run::Analysis" module.

There is available a SOAP access to almost all EMBOSS applications, running at European Bioinformatics Institute.

The documentation of all "public" methods are to be found in "Bio::Factory::AnalysisI".

FEEDBACK

  Mailing Lists
User feedback is an integral part of the evolution of this and other Bioperl modules. Send your comments and suggestions preferably to the Bioperl mailing list. Your participation is much appreciated.

  bioperl-l@bioperl.org                  - General discussion
  http://bioperl.org/wiki/Mailing_lists  - About the mailing lists

  Support
Please direct usage questions or support issues to the mailing list:

bioperl-l@bioperl.org

rather than to the module maintainer directly. Many experienced and reponsive experts will be able look at the problem and quickly address it. Please include a thorough description of the problem with code and data examples if at all possible.

  Reporting Bugs
Report bugs to the Bioperl bug tracking system to help us keep track of the bugs and their resolution. Bug reports can be submitted via the web:

  http://redmine.open-bio.org/projects/bioperl/

AUTHOR
Martin Senger (martin.senger@gmail.com)

COPYRIGHT
Copyright (c) 2003, Martin Senger and EMBL-EBI. All Rights Reserved.

This module is free software; you can redistribute it and/or modify it under the same terms as Perl itself.

DISCLAIMER
This software is provided "as is" without warranty of any kind.

SEE ALSO

•   http://www.ebi.ac.uk/soaplab/Perl_Client.html

APPENDIX
Here is the rest of the object methods. Internal methods are preceded with an underscore _.

  new
 Usage   : my $factory =
             Bio::Tools::Run::AnalysisFactory->new(-access => 'soap',
                                                   -location => 'http://...');
 Returns : a new Bio::Tools::Run::AnalysisFactory object representing a list
           of available analyses
 Args    : There may be additional arguments which are specific
           to the access method (see methods 'new' or '_initialize'
           of the access-specific implementations (such as module
           Bio::Tools::Run::AnalysisFactory::soap for a SOAP-based access).

           The recognised and used arguments are:
             -access
             -location
             -httpproxy
             -timeout

It builds, populates and returns a new "Bio::Tools::Run::AnalysisFactory" object. This is how it is seen from the outside. But in fact, it builds, populates and returns a more specific lower-level object, for example "Bio::Tools::Run::AnalysisFactory::soap" object - which one it is it depends on the "-access" parameter.

-access
    It indicates what lower-level module to load. Default is 'soap'. Other (but future) possibilities are:

       -access => 'novella'
       -access => 'local'

-location
    A location of the service. The contents is access-specific (see details in the lower-level implementation modules).

    Default is "http://www.ebi.ac.uk/soaplab/services" (there are services running at European Bioinformatics Institute on top of most of EMBOSS analyses, and on some others).

-httpproxy
    In addition to the location parameter, you may need to specify also a location/URL of an HTTP proxy server (if your site requires one). The expected format is "http://server:port". There is no default value. It is also an access-specific parameter which may not be used by all access methods.

-timeout
    For long(er) running jobs the HTTP connection may be time-outed. In order to avoid it (or, vice-versa, to call timeout sooner) you may specify "timeout" with the number of seconds the connection will be kept alive. Zero means to keep it alive forever. The default value is two minutes.

  _load_access_module
 Usage   : $class->_load_access_module ($access)
 Returns : 1 on success, undef on failure
 Args    : 'access' should contain the last part of the
           name of a module who does the real implementation

It does (in the run-time) a similar thing as

   require Bio::Tools::Run::AnalysisFactory::$access

It prints an error on STDERR if it fails to find and load the module (for example, because of the compilation errors in the module).

  _guess_access
 Usage   : $class->_guess_access ($rh_params)
 Returns : string with a guessed access protocol (e.g. 'soap'),
           or undef if the guessing failed
 Args    : 'rh_params' is a hash reference containing parameters given
           to the 'new' method.

It makes an expert guess what kind of access/transport protocol should be used to access the underlying analysis. The guess is based on the parameters in rh_params. Remember that this method is called only if there was no -access parameter which could tell directly what access method to use.

  VERSION and Revision
 Usage   : print $Bio::Tools::Run::AnalysisFactory::VERSION;
           print $Bio::Tools::Run::AnalysisFactory::Revision;